﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region - Made modifications sources cl_uppdate v1.30 by: UDG - Di Gioia Consulting - Lugano (CH)
	'****************************************************************************************
	' Class module: AppUpdate
	' Version: 1.00
	' Author: T201016
	' Last Modified: 28.08.2017
	' Location: T201016 - FORUM - B4X Developers (http://www.b4x.com/android/forum/)
	'****************************************************************************************
#End Region

Sub Class_Globals
	Type MyTypeSC (ERR_NOPKG,ERR_NOTXT,ERR_NOAPK,ERR_TXTROW,ERR_HTTP,OK_INIT,OK_CURVER,OK_WEBVER,NO_NEWERAPK, _
	OK_NEWERAPK,OK_DOWNLOAD,OK_INSTALL As Int)

	Type MyTypePV (Callback As Object,Event,sPackageName,sReadLine,sNewVerTxt,sNewVerApk,sApk As String,sStatusCode As Int, _
	sUserName,sUPassword,curver,webver,webclog As String,sVerbose As Boolean,bmSplash As Bitmap,BitImage As BitmapDrawable,pnl1 As Panel)
	
	Type MyTypeGV (pkg As String,svcVerbose As Boolean)

	Dim sc As MyTypeSC 'Status Codes
	Dim pv As MyTypePV 'Private variables
	Dim gv As MyTypeGV 'Global variables - AppUpdate.NewInstall

	' sPackageName  'ex: com.test.myapp
	' sReadLine		'ex: <ChangeLog>ver=x.xx</ChangeLog> the content of the file myapp.txt
	' sNewVerTxt    'ex: http://net/.../myapp.txt --- ex: <ChangeLog>ver=x.xx</ChangeLog>
	' sNewVerApk    'ex: http://net/.../myapp.apk
	' sStatusCode   'negatives denote errors; 0 = lib initialized; positives show current status
	' sUserName     'user name for password protected folders on the server
	' sUPassword    'password related to username above
	' curver,webver 'curver = current version number; webver = version number read from the webserver
	' webclog       'webclog = optional changelog data from webserver
	' sVerbose      'TRUE = a lot of logs

End Sub

'Initialize the object. You can add parameters to this method if needed.
Public Sub Initialize(CallbackModule As Object, EventName As String) As Boolean
	pv.Callback = CallbackModule
	pv.Event = EventName
	
	If CheckConnection Then
		'You connected internet - Continue Initialize the object
		sc.ERR_NOPKG  = -1 'missing package name
		sc.ERR_NOTXT  = -2 'missing webserver's info txt-type file full path
		sc.ERR_NOAPK  = -3 'missing webserver's new apk file full path
		sc.ERR_TXTROW = -4 'wrong row format in txt file
		sc.ERR_HTTP = -100 'HttpUtils error
		sc.OK_INIT = 0
		sc.OK_CURVER = 1   'curver has valid value
		sc.OK_WEBVER = 2
		sc.NO_NEWERAPK = 3 'apk version on webserver is the same as current one
		sc.OK_NEWERAPK = 4 'current apk has a newer version ready to download on the webserver
		sc.OK_DOWNLOAD = 5 'newer apk correctly downloaded from webserver
		sc.OK_INSTALL  = 6 'user asked to install newer apk

  		pv.sPackageName = ""
		pv.sReadLine = ""
		pv.sNewVerTxt = ""
		pv.sNewVerApk = ""
		pv.sUserName = ""
		pv.sUPassword = ""
		pv.sStatusCode = sc.OK_INIT
		pv.curver = ""
		pv.webver = ""
		pv.sVerbose = False

		gv.pkg = ""
		gv.svcVerbose = False 'These variables can be accessed from NewInstall Service.
		Return True
	Else
		Return False
	End If

End Sub

'Sets package name for this app. It should equal the value in menu "Project.Package Name"
'Example: com.test.myapp
Public Sub setPackageName(PN As String)
 	pv.sPackageName = PN
End Sub

'Gets back the package name set for this app. Used internally.
Public Sub getPackageName As String
	Return pv.sPackageName
End Sub

'Complete path to the myapp.txt file having a single line of text formatted as
'ver=x.xx where x.xx corresponds to the newest web-published app's version 
Public Sub setNewVerTxt(NVT As String)
	pv.sNewVerTxt = NVT
End Sub

'Complete path to the new apk for your app, available for download
'Sets <Apk> file name for this app.
'Example: <NVA>="https://dl.dropbox.com/s/u5dsjl4a550bjv8/Tesseract.apk?dl=0", <Apk>="Tesseract.apk"
'Example: <NVA>="https://dl.dropbox.com/s/u5dsjl4a550bjv8/Tesseract.apk?dl=0", <Apk>=""
'Default: <Apk>="" Assigned to the name of the output file for download - "myapp.apk"
Public Sub setNewVerApk(NVA As String, Apk As String)
	pv.sNewVerApk = NVA
	pv.sApk = Apk
	If pv.sApk.Length = 0 Then pv.sApk = "myapp.apk"
	If Not(IsApk(pv.sApk)) Then
		If pv.sApk.IndexOf(".") > -1 Then
			pv.sApk = pv.sApk.SubString2(0,pv.sApk.IndexOf("."))
			pv.sApk = pv.sApk.Replace(".","")
		End If
		pv.sApk = pv.sApk & ".apk"
	End If
End Sub

'Sets Username and Password to use when downloading from a protected website folder
Public Sub setCredentials(UserN As String, UserP As String)
	pv.sUserName  = UserN
	pv.sUPassword = UserP
End Sub		

'Sets verbose mode on/off
Public Sub setVerbose(Verbose As Boolean)
	pv.sVerbose = Verbose
	gv.svcVerbose = Verbose 'from NewInstall Service
End Sub

'Returns current internal status. Negatives denote ERRORS/WARNINGS.
Public Sub getStatus As Int
	Return pv.sStatusCode
End Sub

'Optional sub - super imposes a simple splash screen on the calling Activity. 
'To remove the splash screen, call StopSplashScreen from Activity (generally in the callback function. See "Initialize")
'CallingAct - Activity object whose layout will be super imposed with BM in a panel
Public Sub SetAndStartSplashScreen(CallingAct As Activity)
	Dim BM As Bitmap
	BM = LoadBitmap(File.DirAssets, "splash.png") 'BM - Bitmap object to be shown while apk checking is in progress
	pv.bmSplash = BM
	If pv.bmSplash.IsInitialized Then
		pv.pnl1.Initialize("pnl1")
		pv.BitImage.Initialize(pv.bmSplash)
		pv.BitImage.Gravity = Gravity.FILL
		CallingAct.AddView(pv.pnl1, 0, 0, CallingAct.Width, CallingAct.Height)
		pv.pnl1.Background = pv.BitImage
		pv.pnl1.BringToFront
	End If
End Sub

'Stops and removes the super imposed splash screen
Public Sub StopSplashScreen
	If pv.bmSplash.IsInitialized Then pv.pnl1.RemoveView
End Sub

'Returns current version number value (as a string)  
'Valid only after calling ReadCurVN
Public Sub getCurVN As String
	Return pv.curver
End Sub

'Returns the version number value (as a string) as read from the myapp.txt file on the webserver. 
'Valid only after calling ReadWebVN
Public Sub getWebVN As String
	Return pv.webver
End Sub

'Returns optional change log data (as a string) as read from the myapp.txt file on the webserver  
'Valid only after calling ReadWebVN
Public Sub getWebChangeLog As String
	Return pv.webclog
End Sub

'Reads current version number from running copy of apk (see #VersionName).
'Valid if StatusCode = OK_CURVER
Public Sub ReadCurVN
	Log("---- AppUpdating.ReadCurVN")
	'check whether PackageName was declared
	If pv.sPackageName = "" Then 
		pv.sStatusCode = sc.ERR_NOPKG
		If pv.sVerbose Then Log(TAB & "missing package name for current version check")
		pv.curver = ""
	Else
		Dim pm As PackageManager
		pv.curver = pm.GetVersionName(pv.sPackageName)
		pv.sStatusCode = sc.OK_CURVER 'got current version from Project Attributes
		If pv.sVerbose Then Log(TAB & "Current Version: " & pv.curver)
		Dim TextReader1 As TextReader
		TextReader1.Initialize(File.OpenInput(File.DirRootExternal & "/Download","myapp.txt"))
		pv.sReadLine = ExtractCL(TextReader1.ReadAll)
	End If
End Sub

'Reads version number as published in the myapp.txt file on webserver
'Valid if StatusCode = OK_WEBVER
Public Sub ReadWebVN
	Log("---- AppUpdating.ReadWebVN")
	' check whether NewVerTxt file was declared
	If pv.sNewVerTxt = "" Then
		pv.sStatusCode = sc.ERR_NOTXT
		If pv.sVerbose Then Log(TAB & "missing txt file full path indication")
		pv.webver = ""
		Return
	End If
	DownloadService.URL = pv.sNewVerTxt
	DownloadService.Target = File.OpenOutput(File.DirRootExternal & "/Download","myapp.txt", False)
	StartService(DownloadService)
End Sub

'Downloads newer apk from webserver
Public Sub DownloadApk
	Log("---- AppUpdating.DownloadApk")
	'check whether NewVerApk was declared
	If pv.sNewVerApk = "" Then
		pv.sStatusCode = sc.ERR_NOAPK
		If pv.sVerbose Then Log(TAB & "missing apk file full path indication or missing name for App")
		Return
	End If
	DownloadService.URL = pv.sNewVerApk
	DownloadService.Target = File.OpenOutput(File.DirRootExternal & "/Download",pv.sApk, False)
	StartService(DownloadService)
End Sub

'Installs an already downloaded apk
Public Sub InstallApk
	Log("---- AppUpdating.InstallApk")
	'intent to install
	Dim i As Intent
	i.Initialize(i.ACTION_VIEW, "file://" & File.Combine(File.DirRootExternal & "/Download", pv.sApk))
	i.SetType("application/vnd.android.package-archive")
	StartActivity(i)
	pv.sStatusCode = sc.OK_INSTALL 
	If pv.sVerbose Then Log(TAB & "user asked to install newer apk")
End Sub

'Check on website for a newer apk version and (if any exists) downloads it.
'We don't know if the user will then install it..
Public Sub UpdateApk
	Log("---- AppUpdating.UpdateApk")
	'check whether PackageName was declared
	If pv.sPackageName = "" Then 
		pv.sStatusCode = sc.ERR_NOPKG
		If pv.sVerbose Then Log(TAB & "missing package name for current version check")
		pv.curver = ""
		Return
	End If	
	Dim pm As PackageManager
	pv.curver = pm.GetVersionName(pv.sPackageName)
	pv.sStatusCode = sc.OK_CURVER 'read current version from package name
	If pv.sVerbose Then Log(TAB & "Current Version: " & pv.curver)
	'check whether NewVerTxt file was declared
	If pv.sNewVerTxt = "" Then
		pv.sStatusCode = sc.ERR_NOTXT
		If pv.sVerbose Then Log(TAB & "missing txt file full path indication")
		pv.webver = ""
		Return
	End If
	DownloadService.URL = pv.sNewVerTxt
	DownloadService.Target = File.OpenOutput(File.DirRootExternal & "/Download","myapp.txt", False)
	StartService(DownloadService)
End Sub

'Downloads newer apk and asks user to install it
Private Sub ApkUpdate
	Log(TAB & "---- ApkUpdate")
	'check whether NewVerApk was declared
	If pv.sNewVerApk = "" Then
		pv.sStatusCode = sc.ERR_NOAPK
		If pv.sVerbose Then Log(TAB & "missing apk file full path indication")
		Return
	End If
	DownloadService.URL = pv.sNewVerApk
	DownloadService.Target = File.OpenOutput(File.DirRootExternal & "/Download",pv.sApk, False)
	StartService(DownloadService)
	pv.sStatusCode = sc.OK_DOWNLOAD
	If pv.sVerbose Then Log(TAB & "new apk version downloaded and ready to install")
	Dim i As Intent
	i.Initialize(i.ACTION_VIEW, "file://" & File.Combine(File.DirRootExternal & "/Download", pv.sApk)) 'intent to install
	i.SetType("application/vnd.android.package-archive")
	StartActivity(i)
	pv.sStatusCode = sc.OK_INSTALL 
	If pv.sVerbose Then Log(TAB & "user asked to install new apk")
End Sub

' extract version number from the single row in sNewVerTxt text file
' expected row format: ver=x.xx where "ver" could be any term and x.xx is then version number
' Attn: no spaces allowed between equal sign and version number
Private Sub ExtractVN(TxtRow As String) As String
	Dim i As Int
	i=TxtRow.IndexOf("=")
	If i <> -1 Then
		Dim j As Int
		Dim s  As String
		j=TxtRow.IndexOf("<ChangeLog>")
		If j <> - 1 Then s=TxtRow.SubString2(i+1,j) Else s=TxtRow.SubString(i+1)
		s=s.Replace(CRLF,"")
		Return s
	Else 
		Return ""
	End If
End Sub

'extract change log data from the sNewVerTxt text file
'Info must be placed between <ChangeLog> and </ChangeLog> markers
Private Sub ExtractCL(TxtRow As String) As String
	Dim i As Int
	i=TxtRow.IndexOf("<ChangeLog>")
	If i <> -1 Then
		Dim j As Int
		j=TxtRow.IndexOf("</ChangeLog>")
		If j <> -1 Then Return TxtRow.SubString2(i+11,j) Else Return TxtRow.SubString(i+11)
	Else 
		Return ""
	End If
End Sub

Public Sub JobWebVNonly
	Log(TAB & "---- JobWebVNonly")
	If pv.sVerbose Then Log(TAB & "Read while in JobWebVNonly: x.xx")
	pv.webver = ExtractVN(pv.sReadLine) 'GetString.SubString(4)
	pv.webclog = ExtractCL(pv.sReadLine) 'optional changelog data
	If pv.webver = "" Then
		pv.sStatusCode = sc.ERR_TXTROW
	Else	
		pv.sStatusCode = sc.OK_WEBVER 'read apk's version number as published on webserver
		If pv.sVerbose Then Log(TAB & "Web version number: " & pv.webver)
	End If	
End Sub

Public Sub JobWebVNcompare
	Log(TAB & "---- JoWebVNcompare")
    If pv.sVerbose Then Log(TAB & "Read while in webVNcompare: x.xx")
	pv.webver = ExtractVN(pv.sReadLine) 'GetString.SubString(4)
	pv.webclog = ExtractCL(pv.sReadLine) 'optional changelog data
	If pv.webver = "" Then
		pv.sStatusCode = sc.ERR_TXTROW
		Return
	Else	
		pv.sStatusCode = sc.OK_WEBVER 'read apk's version number as published on webserver
		If pv.sVerbose Then Log(TAB & "Web version number: " & pv.webver)
	End If	
	If pv.curver < pv.webver Then
		pv.sStatusCode = sc.OK_NEWERAPK 'newer apk version available on webserver
		If pv.sVerbose Then Log(TAB & "Newer apk version available. Now I try its downloading")
		ApkUpdate 'download and install
	Else
		pv.sStatusCode = sc.NO_NEWERAPK
		If pv.sVerbose Then Log(TAB & "Newer apk version no available on webserver")
	End If
End Sub

'Action requested is over; it calls the callback function, if any exists
Public Sub Finish(action As Int)
	If SubExists(pv.Callback,pv.Event&"_LookForNewVersion") Then
		CallSub2(pv.Callback,pv.Event&"_LookForNewVersion",action)
	End If		
End Sub

Private Sub IsApk(NomFichier As String) As Boolean
	Private Minus As String
	Minus = NomFichier.ToLowerCase
	Return (Minus.EndsWith(".apk"))
End Sub

Private Sub CheckConnection As Boolean
    Dim p As Phone
	Dim o As Boolean = False
   
   Select p.GetDataState
   	 Case "CONNECTED"
        o = True
	 Case "DISCONNECTED","SUSPENDED"
      	o = False
   End Select
   
    If (p.GetSettings ("wifi_on") = 1) Or o = True Then
        o = True
    End If

	If Not(o) Then
		Msgbox("You didn't connect internet", "Connection WiFi")
	End If
	Return (o)
End Sub

Public Sub Wifi_Settings
	Dim i As Intent
    i.Initialize("android.settings.WIFI_SETTINGS", "")
    StartActivity(i)
End Sub

'1) Holding the current version number in simple text file on your web server
'2) Download this file with HttpUtils.Download
'3) Read contents with HttpUtils.GetString
'4) Check against installed version
'5) If installed < current Then
'6) Download new 'apk' file with HttpUtils.Download
'7) Install