﻿Type=Service
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'	Service module
Sub Process_Globals
	Dim HC As OkHttpClient
	Dim URL As String
	Dim Target As OutputStream
	Dim JobStatus As Int
	Dim STATUS_NONE, STATUS_WORKING, STATUS_DONE As Int
	STATUS_NONE = 0
	STATUS_WORKING = 1
	STATUS_DONE = 2
	Dim DoneSuccessfully As Boolean
	Dim Notification1 As Notification
End Sub

Sub Service_Create
	HC.Initialize("HC")
	Notification1.Initialize
	Notification1.Icon = "icon"
	Notification1.Vibrate = False
End Sub

Sub Service_Start
	Dim request As OkHttpRequest
	request.InitializeGet(URL)
	HC.Execute(request, 1)
	JobStatus = STATUS_WORKING
	Notification1.SetInfo("Status Service", "It takes to download, please wait", Me)
	Notification1.Sound = False
	Service.StartForeground(1, Notification1)
End Sub

Sub HC_ResponseError (Reason As String, StatusCode As Int, TaskId As Int)
	DoneSuccessfully = False
	Complete
End Sub

Sub HC_ResponseSuccess (Response As OkHttpResponse, TaskId As Int)
	Response.GetAsynchronously("Response", Target, True, TaskId)
End Sub

Sub Response_StreamFinish (Success As Boolean, TaskId As Int)
	If Success = False Then
		ToastMessageShow("Error downloading file: " & LastException.Message, True)
	Else
		ToastMessageShow("Download successfully.", True)
		Notification1.Sound = True
	End If
	DoneSuccessfully = Success
	Complete
End Sub

Sub Complete
	JobStatus = STATUS_DONE
	Service.StopForeground(1)
	If IsPaused(Me) Or DoneSuccessfully Then
		Notification1.Sound = True
		If DoneSuccessfully Then
			Notification1.SetInfo("Status Service", "Download complete", Me)
		Else
			Notification1.SetInfo("Status Service", "Error downloading", Me)
		End If
		Notification1.AutoCancel = True
		Notification1.Notify(1) 'Finished downloading
	End If
End Sub

Sub Service_Destroy
End Sub